commit 06b34c0d76153549fb83001c3d90b798066a1851
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Fri Mar 17 18:59:56 2023 +0100

    tree-inline: Fix up multiversioning with vector arguments [PR105554]
    
    The following testcase ICEs, because we call tree_function_versioning from
    old_decl which has target attributes not supporting V4DImode and so
    DECL_MODE of DECL_ARGUMENTS is BLKmode, while new_decl supports those.
    tree_function_versioning initially copies DECL_RESULT and DECL_ARGUMENTS
    from old_decl to new_decl, then calls initialize_cfun to create cfun
    and only when the cfun is created it can later actually remap_decl
    DECL_RESULT and DECL_ARGUMENTS etc.
    The problem is that initialize_cfun -> push_struct_function ->
    allocate_struct_function calls relayout_decl on DECL_RESULT and
    DECL_ARGUMENTS, which clobbers DECL_MODE of old_decl and we then ICE because
    of it.
    In particular, allocate_struct_function does:
          if (!abstract_p)
            {
              /* Now that we have activated any function-specific attributes
                 that might affect layout, particularly vector modes, relayout
                 each of the parameters and the result.  */
              relayout_decl (result);
              for (tree parm = DECL_ARGUMENTS (fndecl); parm;
                   parm = DECL_CHAIN (parm))
                relayout_decl (parm);
    
              /* Similarly relayout the function decl.  */
              targetm.target_option.relayout_function (fndecl);
            }
    
          if (!abstract_p && aggregate_value_p (result, fndecl))
            {
     #ifdef PCC_STATIC_STRUCT_RETURN
              cfun->returns_pcc_struct = 1;
     #endif
              cfun->returns_struct = 1;
            }
    Now, in the case of tree_function_versioning, I believe all that we need
    from these is possibly the
    targetm.target_option.relayout_function (fndecl);
    call (arm only), we will remap DECL_RESULT and DECL_ARGUMENTS later on
    and copy_decl_for_dup_finish in that case will handle all we need:
      /* For vector typed decls make sure to update DECL_MODE according
         to the new function context.  */
      if (VECTOR_TYPE_P (TREE_TYPE (copy)))
        SET_DECL_MODE (copy, TYPE_MODE (TREE_TYPE (copy)));
    We don't need the cfun->returns_*struct either, because we override it
    in initialize_cfun a few lines later:
      /* Copy items we preserve during cloning.  */
    ...
      cfun->returns_struct = src_cfun->returns_struct;
      cfun->returns_pcc_struct = src_cfun->returns_pcc_struct;
    
    So, to avoid the clobbering of DECL_RESULT/DECL_ARGUMENTS of old_decl,
    the following patch arranges allocate_struct_function to be called with
    abstract_p true and calls targetm.target_option.relayout_function (fndecl);
    by hand.
    
    The removal of DECL_RESULT/DECL_ARGUMENTS copying at the start of
    initialize_cfun is removed because the only caller -
    tree_function_versioning, does that unconditionally before.
    
    2023-03-17  Jakub Jelinek  <jakub@redhat.com>
    
            PR target/105554
            * function.h (push_struct_function): Add ABSTRACT_P argument defaulted
            to false.
            * function.c (push_struct_function): Add ABSTRACT_P argument, pass it
            to allocate_struct_function instead of false.
            * tree-inline.c (initialize_cfun): Don't copy DECL_ARGUMENTS
            nor DECL_RESULT here.  Pass true as ABSTRACT_P to
            push_struct_function.  Call targetm.target_option.relayout_function
            after it.
            (tree_function_versioning): Formatting fix.
    
            * gcc.target/i386/pr105554.c: New test.
    
    (cherry picked from commit 24c06560a7fa39049911eeb8777325d112e0deb9)

diff --git a/gcc/function.c b/gcc/function.c
index d26392a252c..d937873a149 100644
--- a/gcc/function.c
+++ b/gcc/function.c
@@ -4848,7 +4848,7 @@ allocate_struct_function (tree fndecl, bool abstract_p)
    instead of just setting it.  */
 
 void
-push_struct_function (tree fndecl)
+push_struct_function (tree fndecl, bool abstract_p)
 {
   /* When in_dummy_function we might be in the middle of a pop_cfun and
      current_function_decl and cfun may not match.  */
@@ -4857,7 +4857,7 @@ push_struct_function (tree fndecl)
 	      || (cfun && current_function_decl == cfun->decl));
   cfun_stack.safe_push (cfun);
   current_function_decl = fndecl;
-  allocate_struct_function (fndecl, false);
+  allocate_struct_function (fndecl, abstract_p);
 }
 
 /* Reset crtl and other non-struct-function variables to defaults as
diff --git a/gcc/function.h b/gcc/function.h
index 7af1af496ea..58816d2d927 100644
--- a/gcc/function.h
+++ b/gcc/function.h
@@ -666,7 +666,7 @@ extern void pop_cfun (void);
 extern int get_next_funcdef_no (void);
 extern int get_last_funcdef_no (void);
 extern void allocate_struct_function (tree, bool);
-extern void push_struct_function (tree fndecl);
+extern void push_struct_function (tree fndecl, bool = false);
 extern void push_dummy_function (bool);
 extern void pop_dummy_function (void);
 extern void init_dummy_function_start (void);
diff --git a/gcc/testsuite/gcc.target/i386/pr105554.c b/gcc/testsuite/gcc.target/i386/pr105554.c
new file mode 100644
index 00000000000..08e90bb3368
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr105554.c
@@ -0,0 +1,10 @@
+/* PR target/105554 */
+/* { dg-do compile } */
+/* { dg-options "-O2 -Wno-psabi -mno-sse3" } */
+
+typedef long long v4di __attribute__((__vector_size__(32)));
+
+__attribute__((target_clones ("arch=core-avx2", "default"))) void
+foo (v4di x)
+{
+}
diff --git a/gcc/tree-inline.c b/gcc/tree-inline.c
index 658b09c07d2..1e8351837c2 100644
--- a/gcc/tree-inline.c
+++ b/gcc/tree-inline.c
@@ -2769,16 +2769,12 @@ initialize_cfun (tree new_fndecl, tree callee_fndecl, profile_count count)
 {
   struct function *src_cfun = DECL_STRUCT_FUNCTION (callee_fndecl);
 
-  if (!DECL_ARGUMENTS (new_fndecl))
-    DECL_ARGUMENTS (new_fndecl) = DECL_ARGUMENTS (callee_fndecl);
-  if (!DECL_RESULT (new_fndecl))
-    DECL_RESULT (new_fndecl) = DECL_RESULT (callee_fndecl);
-
   /* Register specific tree functions.  */
   gimple_register_cfg_hooks ();
 
   /* Get clean struct function.  */
-  push_struct_function (new_fndecl);
+  push_struct_function (new_fndecl, true);
+  targetm.target_option.relayout_function (new_fndecl);
 
   /* We will rebuild these, so just sanity check that they are empty.  */
   gcc_assert (VALUE_HISTOGRAMS (cfun) == NULL);
@@ -6266,8 +6262,7 @@ tree_function_versioning (tree old_decl, tree new_decl,
   id.transform_parameter = false;
   id.transform_lang_insert_block = NULL;
 
-  old_entry_block = ENTRY_BLOCK_PTR_FOR_FN
-    (DECL_STRUCT_FUNCTION (old_decl));
+  old_entry_block = ENTRY_BLOCK_PTR_FOR_FN (DECL_STRUCT_FUNCTION (old_decl));
   DECL_RESULT (new_decl) = DECL_RESULT (old_decl);
   DECL_ARGUMENTS (new_decl) = DECL_ARGUMENTS (old_decl);
   initialize_cfun (new_decl, old_decl,

